##// END OF EJS Templates
Fixed: Disable RPi2/3 under-volt warnings
drtyhlpr -
r132:7274c6a5ff6a
parent child
Show More
@@ -1,612 +1,614
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 10+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
57 57 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
58 58 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
59 59
60 60 # URLs
61 61 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
62 62 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
63 63 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
64 64 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
65 65 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
66 66 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
67 67
68 68 # Build directories
69 69 BASEDIR="$(pwd)/images/${RELEASE}"
70 70 BUILDDIR="${BASEDIR}/build"
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 85 PASSWORD=${PASSWORD:=raspberry}
86 86 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 87 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 88 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 89 EXPANDROOT=${EXPANDROOT:=true}
90 90
91 91 # Keyboard settings
92 92 XKB_MODEL=${XKB_MODEL:=""}
93 93 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 94 XKB_VARIANT=${XKB_VARIANT:=""}
95 95 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 96
97 97 # Network settings (DHCP)
98 98 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 99
100 100 # Network settings (static)
101 101 NET_ADDRESS=${NET_ADDRESS:=""}
102 102 NET_GATEWAY=${NET_GATEWAY:=""}
103 103 NET_DNS_1=${NET_DNS_1:=""}
104 104 NET_DNS_2=${NET_DNS_2:=""}
105 105 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 106 NET_NTP_1=${NET_NTP_1:=""}
107 107 NET_NTP_2=${NET_NTP_2:=""}
108 108
109 109 # APT settings
110 110 APT_PROXY=${APT_PROXY:=""}
111 111 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 112
113 113 # Feature settings
114 114 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 115 ENABLE_I2C=${ENABLE_I2C:=false}
116 116 ENABLE_SPI=${ENABLE_SPI:=false}
117 117 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 118 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 119 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 120 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 121 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 122 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 123 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 124 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 125 ENABLE_XORG=${ENABLE_XORG:=false}
126 126 ENABLE_WM=${ENABLE_WM:=""}
127 127 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 128 ENABLE_USER=${ENABLE_USER:=true}
129 129 USER_NAME=${USER_NAME:="pi"}
130 130 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 131
132 132 # SSH settings
133 133 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
134 134 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
135 135 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
136 136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
137 137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
138 138
139 139 # Advanced settings
140 140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
141 141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
142 142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
143 143 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
144 144 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
145 145 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
146 146 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
147 147 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
148 148 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
149 149 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
150 150
151 151 # Kernel compilation settings
152 152 BUILD_KERNEL=${BUILD_KERNEL:=false}
153 153 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
154 154 KERNEL_THREADS=${KERNEL_THREADS:=1}
155 155 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
156 156 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
157 157 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
158 158
159 159 # Kernel compilation from source directory settings
160 160 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
161 161 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
162 162 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
163 163 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
164 164
165 165 # Reduce disk usage settings
166 166 REDUCE_APT=${REDUCE_APT:=true}
167 167 REDUCE_DOC=${REDUCE_DOC:=true}
168 168 REDUCE_MAN=${REDUCE_MAN:=true}
169 169 REDUCE_VIM=${REDUCE_VIM:=false}
170 170 REDUCE_BASH=${REDUCE_BASH:=false}
171 171 REDUCE_HWDB=${REDUCE_HWDB:=true}
172 172 REDUCE_SSHD=${REDUCE_SSHD:=true}
173 173 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
174 174
175 175 # Encrypted filesystem settings
176 176 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
177 177 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
178 178 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
179 179 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
180 180 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
181 181
182 182 # Stop the Crypto Wars
183 183 DISABLE_FBI=${DISABLE_FBI:=false}
184 184
185 185 # Chroot scripts directory
186 186 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
187 187
188 188 # Packages required in the chroot build environment
189 189 APT_INCLUDES=${APT_INCLUDES:=""}
190 190 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
191 191
192 192 # Packages required for bootstrapping
193 193 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc"
194 194 MISSING_PACKAGES=""
195 195
196 196 set +x
197 197
198 198 # Set Raspberry Pi model specific configuration
199 199 if [ "$RPI_MODEL" = 2 ] ; then
200 200 DTB_FILE=${RPI2_DTB_FILE}
201 201 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
202 202 elif [ "$RPI_MODEL" = 3 ] ; then
203 203 DTB_FILE=${RPI3_DTB_FILE}
204 204 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
205 205 BUILD_KERNEL=true
206 206 else
207 207 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
208 208 exit 1
209 209 fi
210 210
211 211 # Check if the internal wireless interface is supported by the RPi model
212 212 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
213 213 echo "error: The selected Raspberry Pi model has no internal wireless interface"
214 214 exit 1
215 215 fi
216 216
217 217 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
218 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
219 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
220 exit 1
218 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
219 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
220 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
221 exit 1
222 fi
221 223 fi
222 224
223 225 # Set compiler packages and build RPi2/3 Linux kernel if required by Debian release
224 226 if [ "$RELEASE" = "jessie" ] ; then
225 227 COMPILER_PACKAGES="linux-compiler-gcc-4.8-arm g++ make bc"
226 228 elif [ "$RELEASE" = "stretch" ] ; then
227 229 COMPILER_PACKAGES="linux-compiler-gcc-5-arm g++ make bc"
228 230 BUILD_KERNEL=true
229 231 else
230 232 echo "error: Debian release ${RELEASE} is not supported!"
231 233 exit 1
232 234 fi
233 235
234 236 # Add packages required for kernel cross compilation
235 237 if [ "$BUILD_KERNEL" = true ] ; then
236 238 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
237 239 fi
238 240
239 241 # Add libncurses5 to enable kernel menuconfig
240 242 if [ "$KERNEL_MENUCONFIG" = true ] ; then
241 243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
242 244 fi
243 245
244 246 # Stop the Crypto Wars
245 247 if [ "$DISABLE_FBI" = true ] ; then
246 248 ENABLE_CRYPTFS=true
247 249 fi
248 250
249 251 # Add cryptsetup package to enable filesystem encryption
250 252 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
251 253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
252 254 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
253 255
254 256 if [ -z "$CRYPTFS_PASSWORD" ] ; then
255 257 echo "error: no password defined (CRYPTFS_PASSWORD)!"
256 258 exit 1
257 259 fi
258 260 ENABLE_INITRAMFS=true
259 261 fi
260 262
261 263 # Add initramfs generation tools
262 264 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
263 265 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
264 266 fi
265 267
266 268 # Add device-tree-compiler required for building the U-Boot bootloader
267 269 if [ "$ENABLE_UBOOT" = true ] ; then
268 270 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
269 271 fi
270 272
271 273 # Check if root SSH (v2) public key file exists
272 274 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
273 275 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
274 276 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
275 277 exit 1
276 278 fi
277 279 fi
278 280
279 281 # Check if $USER_NAME SSH (v2) public key file exists
280 282 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
281 283 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
282 284 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
283 285 exit 1
284 286 fi
285 287 fi
286 288
287 289 # Check if all required packages are installed on the build system
288 290 for package in $REQUIRED_PACKAGES ; do
289 291 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
290 292 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
291 293 fi
292 294 done
293 295
294 296 # If there are missing packages ask confirmation for install, or exit
295 297 if [ -n "$MISSING_PACKAGES" ] ; then
296 298 echo "the following packages needed by this script are not installed:"
297 299 echo "$MISSING_PACKAGES"
298 300
299 301 echo -n "\ndo you want to install the missing packages right now? [y/n] "
300 302 read confirm
301 303 [ "$confirm" != "y" ] && exit 1
302 304
303 305 # Make sure all missing required packages are installed
304 306 apt-get -qq -y install ${MISSING_PACKAGES}
305 307 fi
306 308
307 309 # Check if ./bootstrap.d directory exists
308 310 if [ ! -d "./bootstrap.d/" ] ; then
309 311 echo "error: './bootstrap.d' required directory not found!"
310 312 exit 1
311 313 fi
312 314
313 315 # Check if ./files directory exists
314 316 if [ ! -d "./files/" ] ; then
315 317 echo "error: './files' required directory not found!"
316 318 exit 1
317 319 fi
318 320
319 321 # Check if specified KERNELSRC_DIR directory exists
320 322 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
321 323 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
322 324 exit 1
323 325 fi
324 326
325 327 # Check if specified CHROOT_SCRIPTS directory exists
326 328 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
327 329 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
328 330 exit 1
329 331 fi
330 332
331 333 # Check if specified device mapping already exists (will be used by cryptsetup)
332 334 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
333 335 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
334 336 exit 1
335 337 fi
336 338
337 339 # Don't clobber an old build
338 340 if [ -e "$BUILDDIR" ] ; then
339 341 echo "error: directory ${BUILDDIR} already exists, not proceeding"
340 342 exit 1
341 343 fi
342 344
343 345 # Setup chroot directory
344 346 mkdir -p "${R}"
345 347
346 348 # Check if build directory has enough of free disk space >512MB
347 349 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
348 350 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
349 351 exit 1
350 352 fi
351 353
352 354 set -x
353 355
354 356 # Call "cleanup" function on various signals and errors
355 357 trap cleanup 0 1 2 3 6
356 358
357 359 # Add required packages for the minbase installation
358 360 if [ "$ENABLE_MINBASE" = true ] ; then
359 361 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
360 362 fi
361 363
362 364 # Add required locales packages
363 365 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
364 366 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
365 367 fi
366 368
367 369 # Add parted package, required to get partprobe utility
368 370 if [ "$EXPANDROOT" = true ] ; then
369 371 APT_INCLUDES="${APT_INCLUDES},parted"
370 372 fi
371 373
372 374 # Add dbus package, recommended if using systemd
373 375 if [ "$ENABLE_DBUS" = true ] ; then
374 376 APT_INCLUDES="${APT_INCLUDES},dbus"
375 377 fi
376 378
377 379 # Add iptables IPv4/IPv6 package
378 380 if [ "$ENABLE_IPTABLES" = true ] ; then
379 381 APT_INCLUDES="${APT_INCLUDES},iptables"
380 382 fi
381 383
382 384 # Add openssh server package
383 385 if [ "$ENABLE_SSHD" = true ] ; then
384 386 APT_INCLUDES="${APT_INCLUDES},openssh-server"
385 387 fi
386 388
387 389 # Add alsa-utils package
388 390 if [ "$ENABLE_SOUND" = true ] ; then
389 391 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
390 392 fi
391 393
392 394 # Add rng-tools package
393 395 if [ "$ENABLE_HWRANDOM" = true ] ; then
394 396 APT_INCLUDES="${APT_INCLUDES},rng-tools"
395 397 fi
396 398
397 399 # Add fbturbo video driver
398 400 if [ "$ENABLE_FBTURBO" = true ] ; then
399 401 # Enable xorg package dependencies
400 402 ENABLE_XORG=true
401 403 fi
402 404
403 405 # Add user defined window manager package
404 406 if [ -n "$ENABLE_WM" ] ; then
405 407 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
406 408
407 409 # Enable xorg package dependencies
408 410 ENABLE_XORG=true
409 411 fi
410 412
411 413 # Add xorg package
412 414 if [ "$ENABLE_XORG" = true ] ; then
413 415 APT_INCLUDES="${APT_INCLUDES},xorg"
414 416 fi
415 417
416 418 # Replace selected packages with smaller clones
417 419 if [ "$ENABLE_REDUCE" = true ] ; then
418 420 # Add levee package instead of vim-tiny
419 421 if [ "$REDUCE_VIM" = true ] ; then
420 422 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
421 423 fi
422 424
423 425 # Add dropbear package instead of openssh-server
424 426 if [ "$REDUCE_SSHD" = true ] ; then
425 427 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
426 428 fi
427 429 fi
428 430
429 431 # Configure kernel sources if no KERNELSRC_DIR
430 432 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
431 433 KERNELSRC_CONFIG=true
432 434 fi
433 435
434 436 # Configure reduced kernel
435 437 if [ "$KERNEL_REDUCE" = true ] ; then
436 438 KERNELSRC_CONFIG=false
437 439 fi
438 440
439 441 # Execute bootstrap scripts
440 442 for SCRIPT in bootstrap.d/*.sh; do
441 443 head -n 3 "$SCRIPT"
442 444 . "$SCRIPT"
443 445 done
444 446
445 447 ## Execute custom bootstrap scripts
446 448 if [ -d "custom.d" ] ; then
447 449 for SCRIPT in custom.d/*.sh; do
448 450 . "$SCRIPT"
449 451 done
450 452 fi
451 453
452 454 # Execute custom scripts inside the chroot
453 455 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
454 456 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
455 457 chroot_exec /bin/bash -x <<'EOF'
456 458 for SCRIPT in /chroot_scripts/* ; do
457 459 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
458 460 $SCRIPT
459 461 fi
460 462 done
461 463 EOF
462 464 rm -rf "${R}/chroot_scripts"
463 465 fi
464 466
465 467 # Remove apt-utils
466 468 if [ "$RELEASE" = "jessie" ] ; then
467 469 chroot_exec apt-get purge -qq -y --force-yes apt-utils
468 470 fi
469 471
470 472 # Generate required machine-id
471 473 MACHINE_ID=$(dbus-uuidgen)
472 474 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
473 475 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
474 476
475 477 # APT Cleanup
476 478 chroot_exec apt-get -y clean
477 479 chroot_exec apt-get -y autoclean
478 480 chroot_exec apt-get -y autoremove
479 481
480 482 # Unmount mounted filesystems
481 483 umount -l "${R}/proc"
482 484 umount -l "${R}/sys"
483 485
484 486 # Clean up directories
485 487 rm -rf "${R}/run/*"
486 488 rm -rf "${R}/tmp/*"
487 489
488 490 # Clean up files
489 491 rm -f "${ETC_DIR}/ssh/ssh_host_*"
490 492 rm -f "${ETC_DIR}/dropbear/dropbear_*"
491 493 rm -f "${ETC_DIR}/apt/sources.list.save"
492 494 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
493 495 rm -f "${ETC_DIR}/*-"
494 496 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
495 497 rm -f "${ETC_DIR}/resolv.conf"
496 498 rm -f "${R}/root/.bash_history"
497 499 rm -f "${R}/var/lib/urandom/random-seed"
498 500 rm -f "${R}/initrd.img"
499 501 rm -f "${R}/vmlinuz"
500 502 rm -f "${R}${QEMU_BINARY}"
501 503
502 504 # Calculate size of the chroot directory in KB
503 505 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
504 506
505 507 # Calculate the amount of needed 512 Byte sectors
506 508 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
507 509 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
508 510 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
509 511
510 512 # The root partition is EXT4
511 513 # This means more space than the actual used space of the chroot is used.
512 514 # As overhead for journaling and reserved blocks 25% are added.
513 515 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
514 516
515 517 # Calculate required image size in 512 Byte sectors
516 518 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
517 519
518 520 # Prepare date string for image file name
519 521 DATE="$(date +%Y-%m-%d)"
520 522
521 523 # Prepare image file
522 524 if [ "$ENABLE_SPLITFS" = true ] ; then
523 525 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
524 526 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
525 527 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
526 528 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
527 529
528 530 # Write firmware/boot partition tables
529 531 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" 2> /dev/null <<EOM
530 532 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
531 533 EOM
532 534
533 535 # Write root partition table
534 536 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" 2> /dev/null <<EOM
535 537 ${TABLE_SECTORS},${ROOT_SECTORS},83
536 538 EOM
537 539
538 540 # Setup temporary loop devices
539 541 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img)"
540 542 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img)"
541 543 else # ENABLE_SPLITFS=false
542 544 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
543 545 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
544 546
545 547 # Write partition table
546 548 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" 2> /dev/null <<EOM
547 549 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
548 550 ${ROOT_OFFSET},${ROOT_SECTORS},83
549 551 EOM
550 552
551 553 # Setup temporary loop devices
552 554 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img)"
553 555 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img)"
554 556 fi
555 557
556 558 if [ "$ENABLE_CRYPTFS" = true ] ; then
557 559 # Create dummy ext4 fs
558 560 mkfs.ext4 "$ROOT_LOOP"
559 561
560 562 # Setup password keyfile
561 563 echo -n ${CRYPTFS_PASSWORD} > .password
562 564 chmod 600 .password
563 565
564 566 # Initialize encrypted partition
565 567 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
566 568
567 569 # Open encrypted partition and setup mapping
568 570 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
569 571
570 572 # Secure delete password keyfile
571 573 shred -zu .password
572 574
573 575 # Update temporary loop device
574 576 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
575 577
576 578 # Wipe encrypted partition (encryption cipher is used for randomness)
577 579 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
578 580 fi
579 581
580 582 # Build filesystems
581 583 mkfs.vfat "$FRMW_LOOP"
582 584 mkfs.ext4 "$ROOT_LOOP"
583 585
584 586 # Mount the temporary loop devices
585 587 mkdir -p "$BUILDDIR/mount"
586 588 mount "$ROOT_LOOP" "$BUILDDIR/mount"
587 589
588 590 mkdir -p "$BUILDDIR/mount/boot/firmware"
589 591 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
590 592
591 593 # Copy all files from the chroot to the loop device mount point directory
592 594 rsync -a "${R}/" "$BUILDDIR/mount/"
593 595
594 596 # Unmount all temporary loop devices and mount points
595 597 cleanup
596 598
597 599 # Create block map file(s) of image(s)
598 600 if [ "$ENABLE_SPLITFS" = true ] ; then
599 601 # Create block map files for "bmaptool"
600 602 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img"
601 603 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img"
602 604
603 605 # Image was successfully created
604 606 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
605 607 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
606 608 else
607 609 # Create block map file for "bmaptool"
608 610 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img"
609 611
610 612 # Image was successfully created
611 613 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
612 614 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant